\input Head

\section{\tt UDTMetaData} (UMD)

% A short (preferably one-line) description of {\tt MyClass}.

The abstract base class of all UDT metadata classes.

\subsection{User Interface}

% The class definition from the header file

\begin{verbatim}

namespace datacondAPI
{

    class UDTMetaData
    {

    public:

	// output

	virtual ILwd::LdasElement* ConvertToIlwd(  const CallChain& Chain, datacondAPI::udt::target_t Target = datacondAPI::udt::TARGET_GENERIC ) const = 0;

    protected:

	// constructors

	UDTMetaData();
	UDTMetaData(const UDTMetaData& value);

	// destructor

	virtual ~UDTMetaData();

	// operator=

	UDTMetaData& operator=(const UDTMetaData& value);

    }; // class UDTMetaData

}; // namespace datacondAPI

\end{verbatim}

\subsection{Description}

% A longer description of what {\tt MyClass} is used for.

{\tt UDTMetaData} partially defines the interface of the UDT metadata classes,
not only mandating the presence of a method for converting the metadata to
an ILWD, but also making several implicitly defined methods {\tt protected} to
discourage the treatment of standalone metadata classes as objects in their own
right.  Metadata should exist only with data; as such, construction and
destruction of metadata is protected, and can only be performed by a derived
class (the data).

\subsection{Operating Instructions}

\subsubsection{Example Usage}

% A verbatim block of example code showing proper usage of {\tt
% MyClass}.

As an abstract base class, the only proper usage of {\tt UDTMetadata} is to
inherit from it.  Note that the implicit methods of the derived class are
{\tt protected}, following the example of the base class.

\begin{verbatim}

namespace datacondAPI
{

  class NameMetaData : public UDTMetaData
  {

  public:

    std::string GetName() const;

    void SetName(const std::string& name);

    virtual ~NameMetaData();

    virtual ILwd::LdasElement* ConvertToIlwd(const CallChain&, datacondAPI::udt::target_t) const;

  protected:

    NameMetaData();
    explicit NameMetaData(const std::string& name);
    NameMetaData(const NameMetaData& name);
    NameMetaData& operator=(const NameMetaData& name);

  private:

    std::string m_name;

  }; // class NameMetaData

} // namespace datacondAPI

\end{verbatim}

\subsubsection{Options/Defaults}

% A list of options or defaults for public methods or member data of
% {\tt MyClass}. 

None.

\subsection{Exceptions}

\subsubsection{Exceptions Thrown}

% A list of exceptions thrown by {\tt MyClass}.

None.  There are no exception sepcifications, so derived classes may throw
exceptions of any type.

\subsubsection{Exceptions Handled}

% A list of exceptions handled by {\tt MyClass}.

None.

\subsection{Algorithms}

% A discussion of the algorithms used by {\tt MyClass}.

None.

\subsection{Accuracy}

% A discussion of issues related to the accuracy of numerical routines
% used by {\tt MyClass}---e.g., approximations,  argument ranges, etc.

Not relevant.

\subsection{Performance}

% A discussion of issues related to the speed (e.g., $O(N\log N)$) of
% computationally demanding routines used by {\tt MyClass}.

Not relevant.

\subsection{Testing}

% A description of any test code/test classes that were used to test
% {\tt MyClass}. 

{\tt UDTMetaData} is implicitly tested by the test routines of its derived
classes.

\subsection{Notes}

% Miscellaneous notes about {\tt MyClass} that do not appear
% elsewhere, things that remain to be done, etc.  

By design, a UDT may multiply inherit from many metadata classes, and
thus indirectly inherit many times from {\tt UDTMetaData}.  As
{\tt UDTMetaData} is abstract, this does not cause ambiguity.

\subsection{See Also}

% A list of derived classes, base classes, etc.\ closely related to
% {\tt MyClass}. 

\subsubsection{Derived classes}
All UDT metadata types.

\subsubsection{Related classes}
{\tt UDT} (Unified data Type).

\subsection{References}

% A list of references for any algorithms, etc.\ used by {\tt
% MyClass}. 

\input Tail

%%% Local Variables: 
%%% mode: latex
%%% TeX-master: "datacondAPI"
%%% End: 
